Public Member Functions | Protected Member Functions | Protected Attributes | Friends

# GDALPamRasterBand Class Reference

Inheritance diagram for GDALPamRasterBand:

List of all members.

## Public Member Functions
virtual void | SetDescription (const char *)
| Set object description.
virtual CPLErr | SetNoDataValue (double)
virtual double | GetNoDataValue (int *pbSuccess=NULL)
| Fetch the no data value for this band.
virtual CPLErr | SetColorTable (GDALColorTable *)
| Set the raster color table.
virtual GDALColorTable * | GetColorTable ()
| Fetch the color table associated with band.
virtual CPLErr | SetColorInterpretation (GDALColorInterp)
| Set color interpretation of a band.
virtual GDALColorInterp | GetColorInterpretation ()
| How should this band be interpreted as color?
virtual const char * | GetUnitType ()
| Return raster unit type.
CPLErr | SetUnitType (const char *)
virtual char ** | GetCategoryNames ()
| Fetch the list of category names for this raster.
virtual CPLErr | SetCategoryNames (char **)
virtual double | GetOffset (int *pbSuccess=NULL)
| Fetch the raster value offset.
CPLErr | SetOffset (double)
virtual double | GetScale (int *pbSuccess=NULL)
| Fetch the raster value scale.
CPLErr | SetScale (double)
virtual CPLErr | GetHistogram (double dfMin, double dfMax, int nBuckets, GUIntBig *panHistogram, int bIncludeOutOfRange, int bApproxOK, GDALProgressFunc, void *pProgressData)
| Compute raster histogram.
virtual CPLErr | GetDefaultHistogram (double *pdfMin, double *pdfMax, int *pnBuckets, GUIntBig **ppanHistogram, int bForce, GDALProgressFunc, void *pProgressData)
| Fetch default raster histogram.
virtual CPLErr | SetDefaultHistogram (double dfMin, double dfMax, int nBuckets, GUIntBig *panHistogram)
virtual CPLErr | SetMetadata (char **papszMetadata, const char *pszDomain="")
| Set metadata.
virtual CPLErr | SetMetadataItem (const char *pszName, const char *pszValue, const char *pszDomain="")
| Set single metadata item.
virtual GDALRasterAttributeTable * | GetDefaultRAT ()
| Fetch default Raster Attribute Table.
virtual CPLErr | SetDefaultRAT (const GDALRasterAttributeTable *)
virtual CPLErr | CloneInfo (GDALRasterBand *poSrcBand, int nCloneInfoFlags)
GDALRasterBandPamInfo * | GetPamInfo ()
## Protected Member Functions
virtual CPLXMLNode * | SerializeToXML (const char *pszVRTPath)
virtual CPLErr | XMLInit (CPLXMLNode *, const char *)
void | PamInitialize ()
void | PamClear ()
## Protected Attributes
GDALRasterBandPamInfo * | psPam
## Friends
class | GDALPamDataset

## Member Function Documentation

char ** GDALPamRasterBand::GetCategoryNames | ( |  | ) | `[virtual]`

Fetch the list of category names for this raster.

The return list is a "StringList" in the sense of the CPL functions. That is a NULL terminated array of strings. Raster values without associated names will have an empty string in the returned list. The first entry in the list is for raster values of zero, and so on.

The returned stringlist should not be altered or freed by the application. It may change on the next GDAL call, so please copy it if it is needed for any period of time.

This method is the same as the C function GDALGetRasterCategoryNames().

Returns:
  list of names, or NULL if none.

Reimplemented from GDALRasterBand.

GDALColorInterp GDALPamRasterBand::GetColorInterpretation | ( |  | ) | `[virtual]`

How should this band be interpreted as color?

GCI_Undefined is returned when the format doesn't know anything about the color interpretation.

This method is the same as the C function GDALGetRasterColorInterpretation().

Returns:
  color interpretation value for band.

Reimplemented from GDALRasterBand.

GDALColorTable * GDALPamRasterBand::GetColorTable | ( |  | ) | `[virtual]`

Fetch the color table associated with band.

If there is no associated color table, the return result is NULL. The returned color table remains owned by the GDALRasterBand, and can't be depended on for long, nor should it ever be modified by the caller.

This method is the same as the C function GDALGetRasterColorTable().

Returns:
  internal color table, or NULL.

Reimplemented from GDALRasterBand.

CPLErr GDALPamRasterBand::GetDefaultHistogram | ( | double * | pdfMin,
|  | double * | pdfMax,
|  | int * | pnBuckets,
|  | GUIntBig ** | ppanHistogram,
|  | int | bForce,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData |
| ) |  |  | `[virtual]`

Fetch default raster histogram.

The default method in GDALRasterBand will compute a default histogram. This method is overriden by derived classes (such as GDALPamRasterBand, VRTDataset, HFADataset...) that may be able to fetch efficiently an already stored histogram.

This method is the same as the C functions GDALGetDefaultHistogram() and GDALGetDefaultHistogramEx().

Parameters:

  | pdfMin | pointer to double value that will contain the lower bound of the histogram.
  | pdfMax | pointer to double value that will contain the upper bound of the histogram.
  | pnBuckets | pointer to int value that will contain the number of buckets in *ppanHistogram.
  | ppanHistogram | pointer to array into which the histogram totals are placed. To be freed with VSIFree
  | bForce | TRUE to force the computation. If FALSE and no default histogram is available, the method will return CE_Warning
  | pfnProgress | function to report progress to completion.
  | pProgressData | application data to pass to pfnProgress.

Returns:
  CE_None on success, CE_Failure if something goes wrong, or CE_Warning if no default histogram is available.

Reimplemented from GDALRasterBand.

GDALRasterAttributeTable * GDALPamRasterBand::GetDefaultRAT | ( |  | ) | `[virtual]`

Fetch default Raster Attribute Table.

A RAT will be returned if there is a default one associated with the band, otherwise NULL is returned. The returned RAT is owned by the band and should not be deleted by the application.

This method is the same as the C function GDALGetDefaultRAT().

Returns:
  NULL, or a pointer to an internal RAT owned by the band.

Reimplemented from GDALRasterBand.

CPLErr GDALPamRasterBand::GetHistogram | ( | double | dfMin,
|  | double | dfMax,
|  | int | nBuckets,
|  | GUIntBig * | panHistogram,
|  | int | bIncludeOutOfRange,
|  | int | bApproxOK,
|  | GDALProgressFunc | pfnProgress,
|  | void * | pProgressData |
| ) |  |  | `[virtual]`

Compute raster histogram.

Note that the bucket size is (dfMax-dfMin) / nBuckets.

For example to compute a simple 256 entry histogram of eight bit data, the following would be suitable. The unusual bounds are to ensure that bucket boundaries don't fall right on integer values causing possible errors due to rounding after scaling.

        GUIntBig anHistogram[256];

        poBand->GetHistogram( -0.5, 255.5, 256, anHistogram, FALSE, FALSE,
                              GDALDummyProgress, NULL );

Note that setting bApproxOK will generally result in a subsampling of the file, and will utilize overviews if available. It should generally produce a representative histogram for the data that is suitable for use in generating histogram based luts for instance. Generally bApproxOK is much faster than an exactly computed histogram.

This method is the same as the C functions GDALGetRasterHistogram() and GDALGetRasterHistogramEx().

Parameters:

  | dfMin | the lower bound of the histogram.
  | dfMax | the upper bound of the histogram.
  | nBuckets | the number of buckets in panHistogram.
  | panHistogram | array into which the histogram totals are placed.
  | bIncludeOutOfRange | if TRUE values below the histogram range will mapped into panHistogram[0], and values above will be mapped into panHistogram[nBuckets-1] otherwise out of range values are discarded.
  | bApproxOK | TRUE if an approximate, or incomplete histogram OK.
  | pfnProgress | function to report progress to completion.
  | pProgressData | application data to pass to pfnProgress.

Returns:
  CE_None on success, or CE_Failure if something goes wrong.

Reimplemented from GDALRasterBand.

double GDALPamRasterBand::GetNoDataValue | ( | int * | pbSuccess = `NULL` | ) | `[virtual]`

Fetch the no data value for this band.

If there is no out of data value, an out of range value will generally be returned. The no data value for a band is generally a special marker value used to mark pixels that are not valid data. Such pixels should generally not be displayed, nor contribute to analysis operations.

This method is the same as the C function GDALGetRasterNoDataValue().

Parameters:

  | pbSuccess | pointer to a boolean to use to indicate if a value is actually associated with this layer. May be NULL (default).

Returns:
  the nodata value for this band.

Reimplemented from GDALRasterBand.

double GDALPamRasterBand::GetOffset | ( | int * | pbSuccess = `NULL` | ) | `[virtual]`

Fetch the raster value offset.

This value (in combination with the GetScale() value) is used to transform raw pixel values into the units returned by GetUnits(). For example this might be used to store elevations in GUInt16 bands with a precision of 0.1, and starting from -100.

Units value = (raw value * scale) + offset

For file formats that don't know this intrinsically a value of zero is returned.

This method is the same as the C function GDALGetRasterOffset().

Parameters:

  | pbSuccess | pointer to a boolean to use to indicate if the returned value is meaningful or not. May be NULL (default).

Returns:
  the raster offset.

Reimplemented from GDALRasterBand.

double GDALPamRasterBand::GetScale | ( | int * | pbSuccess = `NULL` | ) | `[virtual]`

Fetch the raster value scale.

This value (in combination with the GetOffset() value) is used to transform raw pixel values into the units returned by GetUnits(). For example this might be used to store elevations in GUInt16 bands with a precision of 0.1, and starting from -100.

Units value = (raw value * scale) + offset

For file formats that don't know this intrinsically a value of one is returned.

This method is the same as the C function GDALGetRasterScale().

Parameters:

  | pbSuccess | pointer to a boolean to use to indicate if the returned value is meaningful or not. May be NULL (default).

Returns:
  the raster scale.

Reimplemented from GDALRasterBand.

const char * GDALPamRasterBand::GetUnitType | ( |  | ) | `[virtual]`

Return raster unit type.

Return a name for the units of this raster's values. For instance, it might be "m" for an elevation model in meters, or "ft" for feet. If no units are available, a value of "" will be returned. The returned string should not be modified, nor freed by the calling application.

This method is the same as the C function GDALGetRasterUnitType().

Returns:
  unit name string.

Reimplemented from GDALRasterBand.

CPLErr GDALPamRasterBand::SetColorInterpretation | ( | GDALColorInterp | eColorInterp | ) | `[virtual]`

Set color interpretation of a band.

This method is the same as the C function GDALSetRasterColorInterpretation().

Parameters:

  | eColorInterp | the new color interpretation to apply to this band.

Returns:
  CE_None on success or CE_Failure if method is unsupported by format.

Reimplemented from GDALRasterBand.

CPLErr GDALPamRasterBand::SetColorTable | ( | GDALColorTable * | poCT | ) | `[virtual]`

Set the raster color table.

The driver will make a copy of all desired data in the colortable. It remains owned by the caller after the call.

This method is the same as the C function GDALSetRasterColorTable().

Parameters:

  | poCT | the color table to apply. This may be NULL to clear the color table (where supported).

Returns:
  CE_None on success, or CE_Failure on failure. If the action is unsupported by the driver, a value of CE_Failure is returned, but no error is issued.

Reimplemented from GDALRasterBand.

void GDALPamRasterBand::SetDescription | ( | const char * | pszNewDesc | ) | `[virtual]`

Set object description.

The semantics of the description are specific to the derived type. For GDALDatasets it is the dataset name. For GDALRasterBands it is actually a description (if supported) or "".

Normally application code should not set the "description" for GDALDatasets. It is handled internally.

This method is the same as the C function GDALSetDescription().

Reimplemented from GDALMajorObject.

CPLErr GDALPamRasterBand::SetMetadata | ( | char ** | papszMetadataIn,
|  | const char * | pszDomain = `""` |
| ) |  |  | `[virtual]`

Set metadata.

The C function GDALSetMetadata() does the same thing as this method.

Parameters:

  | papszMetadataIn | the metadata in name=value string list format to apply.
  | pszDomain | the domain of interest. Use "" or NULL for the default domain.

Returns:
  CE_None on success, CE_Failure on failure and CE_Warning if the metadata has been accepted, but is likely not maintained persistently by the underlying object between sessions.

Reimplemented from GDALMajorObject.

CPLErr GDALPamRasterBand::SetMetadataItem | ( | const char * | pszName,
|  | const char * | pszValue,
|  | const char * | pszDomain = `""` |
| ) |  |  | `[virtual]`

Set single metadata item.

The C function GDALSetMetadataItem() does the same thing as this method.

Parameters:

  | pszName | the key for the metadata item to fetch.
  | pszValue | the value to assign to the key.
  | pszDomain | the domain to set within, use NULL for the default domain.

Returns:
  CE_None on success, or an error code on failure.

Reimplemented from GDALMajorObject.

The documentation for this class was generated from the following files:

- gdal_pam.h
- gdalpamrasterband.cpp

Generated for GDAL by 1.7.1.